/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'minimips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.minimips.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.minimips.shared.Shared.*;

public final class beq extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         beq.class,
         "beq",
         false,
         new ArgumentDecls()
             .add("rs", ArgumentMode.IN, REG.INFO)
             .add("rt", ArgumentMode.IN, REG.INFO)
             .add("offset", SHORT),
         false,
         false,
         false,
         false,
         false,
         0,
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public IOperation create(Map<String, Object> args) {
      final REG rs = (REG) getArgument("rs", args);
      final REG rt = (REG) getArgument("rt", args);
      final Location offset = (Location) getArgument("offset", args);

      return new beq(rs, rt, offset);
    }
  }

  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "beq",
          true,
          new ArgumentDecls()
              .add("rs", ArgumentMode.IN, REG.INFO)
              .add("rt", ArgumentMode.IN, REG.INFO)
              .add("offset", SHORT),
          true,
          true,
          false,
          false,
          false,
          0
      );
    }

    @Override
    public IOperation create(Map<String, Object> args) {
      final REG rs = (REG) getArgument("rs", args);
      final REG rt = (REG) getArgument("rt", args);
      final Location offset = (Location) getArgument("offset", args);

      return new instruction(
        new beq(
          rs,
          rt,
          offset
        )
      );
    }
  }

  public static final IInfo INFO = new Info();

  private final REG rs;
  private final REG rt;
  private final Location offset;

  public beq(REG rs, REG rt, Location offset) {
    assert REG.INFO.isSupported(rs);
    assert REG.INFO.isSupported(rt);
    assert SHORT.equals(offset.getType());

    this.rs = rs;
    this.rt = rt;
    this.offset = offset;
  }

  @Override
  public String syntax() {
    return String.format("beq %s, %s, <label>%d", rs.syntax(), rt.syntax(), offset.load().bigIntegerValue());
  }

  @Override
  public String image() {
    return String.format("000100%s%s%s", rs.image(), rt.image(), offset.load().toString());
  }

  @Override
  public void action() {
    try {
    actionBegin();
    if (rs.access().load().equals(rt.access().load())) {
      BRANCH.access().store(Data.valueOf(BIT, 0x1));
      JMPADDR.access().store(CIA.access().load().add(Data.valueOf(WORD, 0x4)).add(Data.signExtend(WORD, offset.load()).shiftLeft(Data.valueOf(WORD, 0x2))));
    }
    } finally {
    actionEnd();
    }
  }
}
