/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'minimips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.minimips.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.minimips.shared.Shared.*;

public final class sra extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         sra.class,
         "sra",
         false,
         new ArgumentDecls()
             .add("rd", ArgumentMode.OUT, REG.INFO)
             .add("rt", ArgumentMode.IN, REG.INFO)
             .add("sa", Type.CARD(5)),
         false,
         false,
         false,
         false,
         false,
         0,
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public IOperation create(Map<String, Object> args) {
      final REG rd = (REG) getArgument("rd", args);
      final REG rt = (REG) getArgument("rt", args);
      final Location sa = (Location) getArgument("sa", args);

      return new sra(rd, rt, sa);
    }
  }

  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "sra",
          true,
          new ArgumentDecls()
              .add("rd", ArgumentMode.OUT, REG.INFO)
              .add("rt", ArgumentMode.IN, REG.INFO)
              .add("sa", Type.CARD(5)),
          true,
          true,
          false,
          false,
          false,
          0
      );
    }

    @Override
    public IOperation create(Map<String, Object> args) {
      final REG rd = (REG) getArgument("rd", args);
      final REG rt = (REG) getArgument("rt", args);
      final Location sa = (Location) getArgument("sa", args);

      return new instruction(
        new sra(
          rd,
          rt,
          sa
        )
      );
    }
  }

  public static final IInfo INFO = new Info();

  private final REG rd;
  private final REG rt;
  private final Location sa;

  public sra(REG rd, REG rt, Location sa) {
    assert REG.INFO.isSupported(rd);
    assert REG.INFO.isSupported(rt);
    assert Type.CARD(5).equals(sa.getType());

    this.rd = rd;
    this.rt = rt;
    this.sa = sa;
  }

  @Override
  public String syntax() {
    return String.format("sra %s, %s, %d", rd.syntax(), rt.syntax(), sa.load().bigIntegerValue());
  }

  @Override
  public String image() {
    return String.format("00000000000%s%s%s000011", rt.image(), rd.image(), sa.load().toString());
  }

  @Override
  public void action() {
    try {
    actionBegin();
    rd.access().store(rt.access().load().shiftRight(sa.load()));
    } finally {
    actionEnd();
    }
  }
}
